#pragma once
#include <BasicAbstractions/IDrawable.h>

struct GameContext;

class ProgressBar final : public IDrawable {
public:
    ProgressBar() = default;
    explicit ProgressBar(size_t food_number);
    void update_food_progress_bar(const GameContext& game_context);
    void update_defeat_progress_bar(const GameContext& game_context);
    void draw_into(sf::RenderWindow& window) const override;
private:
    sf::RectangleShape m_bar_background;
    sf::RectangleShape m_bar;
    sf::RectangleShape m_progress_bar;
    sf::Text m_text_before_bar;
    sf::Text m_text_on_bar;
    sf::RectangleShape m_defeats_count_background;
    sf::Text m_defeats_count_text;
    float m_progress_max_width = 0;
};